// dllmain.cpp : DLL AvP[ṼGg |Cg`܂B
#include "stdafx.h"
#include <windows.h>
#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")

#pragma comment(lib, "rpcrt4.lib")

#include "ycapture.h"

WCHAR NAME_CAPTURESOURCE[64] = {0};
GUID CLSID_CaptureSource = {0};
WCHAR CS_EVENT_WRITE[64] = {0};
WCHAR CS_EVENT_READ[64] = {0};
WCHAR CS_SHARED_PATH[64] = {0};

int DEFAULT_WIDTH = 640;
int DEFAULT_HEIGHT = 480;
int MIN_WIDTH = 160;
int MIN_HEIGHT = 120;
int MAX_WIDTH = 640;
int MAX_HEIGHT = 480;
int MAX_FPS = 15;
int MIN_FPS = 1;
int MAX_FRAME_INTERVAL = 10000000 / MAX_FPS;
int MIN_FRAME_INTERVAL = 10000000 / MIN_FPS;
int DEFAULT_FPS = 15;

void ReadConfig(HMODULE hModule);

//
// DllEntryPoint
//
extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		ReadConfig(hModule);
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	
	return DllEntryPoint((HINSTANCE)(hModule), ul_reason_for_call, lpReserved);
}

void ReadConfig(HMODULE hModule){

	// init@C̃pX肷
	WCHAR szModuleFileName[_MAX_PATH * 2] = {0};
	// DLL擾
	GetModuleFileName((HMODULE) hModule, szModuleFileName, _MAX_PATH);
	// gq菜
	PathRemoveExtension(szModuleFileName);
	// .ini
	wcscat_s(szModuleFileName, _MAX_PATH, L".ini");

	// MessageBox(0,(LPCWSTR)szModuleFileName,L"",0);

	// iniǂݍ
	// GUID
	WCHAR GUID_STR[64] = {0};
	GetPrivateProfileString(L"config", L"GUID", L"", GUID_STR, 63, szModuleFileName);
	if (0 == StrCmpW(L"", GUID_STR)){
		memcpy_s((void *)&CLSID_CaptureSource,
			sizeof(CLSID_CaptureSource),
			(void *)&CLSID_DEFAULT_CaptureSource,
			sizeof(CLSID_DEFAULT_CaptureSource)
		);
	}else{
		if (RPC_S_OK != UuidFromStringW((RPC_WSTR)GUID_STR, (UUID *)&CLSID_CaptureSource)){
			memcpy_s((void *)&CLSID_CaptureSource,
				sizeof(CLSID_CaptureSource),
				(void *)&CLSID_DEFAULT_CaptureSource,
				sizeof(CLSID_DEFAULT_CaptureSource)
			);
		}else{
			// Ȃ
		}
	}

	// O
	GetPrivateProfileString(L"config", L"NAME", DEFAULT_NAME_CAPTURESOURCE, NAME_CAPTURESOURCE, 63, szModuleFileName);
	GetPrivateProfileString(L"config", L"CS_EVENT_WRITE", DEFAULT_CS_EVENT_WRITE, CS_EVENT_WRITE, 63, szModuleFileName);
	GetPrivateProfileString(L"config", L"CS_EVENT_READ", DEFAULT_CS_EVENT_READ, CS_EVENT_READ, 63, szModuleFileName);
	GetPrivateProfileString(L"config", L"CS_SHARED_PATH", DEFAULT_CS_SHARED_PATH, CS_SHARED_PATH, 63, szModuleFileName);

	DEFAULT_WIDTH = GetPrivateProfileInt(L"config", L"DEFAULT_WIDTH", 640, szModuleFileName);
	DEFAULT_HEIGHT = GetPrivateProfileInt(L"config", L"DEFAULT_HEIGHT", 480, szModuleFileName);
	MIN_WIDTH = GetPrivateProfileInt(L"config", L"MIN_WIDTH", 160, szModuleFileName);
	MIN_HEIGHT = GetPrivateProfileInt(L"config", L"MIN_HEIGHT", 120, szModuleFileName);
	MAX_WIDTH = GetPrivateProfileInt(L"config", L"MAX_WIDTH", 640, szModuleFileName);
	MAX_HEIGHT = GetPrivateProfileInt(L"config", L"MAX_HEIGHT", 480, szModuleFileName);
	MAX_FPS = GetPrivateProfileInt(L"config", L"MAX_FPS", 15, szModuleFileName);
	MIN_FPS = GetPrivateProfileInt(L"config", L"MIN_FPS", 1, szModuleFileName);
	DEFAULT_FPS = GetPrivateProfileInt(L"config", L"DEFAULT_FPS", 15, szModuleFileName);

	MAX_FRAME_INTERVAL = 10000000 / MAX_FPS;
	MIN_FRAME_INTERVAL = 10000000 / MIN_FPS;

}